const compressor = require('node-minify');

//declare file names etc
const minifyDirPath = "/Users/cmiller/subdir/further-subdir/etc"; //repo youre minifying on
const minifySubDirPath = ["/js/", "/css/"]; //subdirs - usually /css and /js
const fileNames = ["boilerplate.js", "main.js", "plugins.js", "bootstrap.css", "contrast-default.css", "contrast.css", "main.css"]; //files you want to minify

//concat paths
var fullDirPaths = [];
minifySubDirPath.forEach(subDirPath => {
    var string = minifyDirPath.concat(subDirPath);
    fullDirPaths.push(string);
});
var fullFilePaths = [];
fullDirPaths.forEach(fullDirPath => {
    fileNames.forEach(fileName => {
        var path = fullDirPath.concat(fileName);
        if (fullDirPath.includes("/js") && fileName.includes(".js") || fullDirPath.includes("/css") && fileName.includes(".css")) {
            fullFilePaths.push(path);
        }
    });
});

//minify
fullFilePaths.forEach(fullFilePath => {
    console.log('minifying ' + fullFilePath + '...');
    if (fullFilePath.includes('.js')) {
        var noExtPathJs = fullFilePath.replace('.js','');
        var promise = compressor.minify({
            compressor: 'uglifyjs',
            input: fullFilePath,
            output: noExtPathJs.concat(".min.js")
        });

        promise.then(function (min) {
        });
    }
    else {
        var noExtPathCss = fullFilePath.replace('.css','');
        var promise = compressor.minify({
            compressor: 'sqwish',
            input: fullFilePath,
            output: noExtPathCss.concat(".min.css")
        });
        promise.then(function (min) {
        });
    }

    console.log('all done! No errors');
});


